Name:		ice
Version:	1.6.4
Release:	1.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		https://downloadcenter.intel.com//download/29746/Intel-Network-Adapter-Driver-for-E810-Series-Devices-under-Linux-
Packager:	Hewlett-Packard Enterprise Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:    %{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	Linux* Base Driver for the Intel(R) Ethernet Controller (ice)

%define debug_package %{nil}
%define ddpVersion 1.3.26.0

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
BuildRequires: kernel-source kernel-syms
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -f %{SOURCE1} -x %flav -b}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
Intel(R) Gigabit Ethernet Kernel Module for HPE ProLiant systems
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: HPE Intel Gigabit Ethernet driver (ice)
Group: System/Kernel

%description KMP
Intel(R) Gigabit Ethernet Kernel Module for HPE ProLiant systems
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the HPE Intel Gigabit Ethernet driver (ice)

%prep
%setup
set -- *
mkdir source
mv "$@" source/
mkdir obj
echo "override ice * weak-updates/%{name}" > %{name}.conf
echo "add_drivers+=\" ice \"" > %{name}-oob.conf

%build
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
        make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor}

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < source/ice.7 > source/ice.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor} install

	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 source/ice.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/ice.7.gz
install -d %{buildroot}%{_sysconfdir}/depmod.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
install -D -m 644 source/ddp/ice-1.3.26.0.pkg %{buildroot}/lib/firmware/updates/intel/ice/ddp/ice-1.3.26.0.pkg
install -D -m 644 source/ddp/LICENSE %{buildroot}/lib/firmware/updates/intel/ice/ddp/LICENSE 2>/dev/null || truels 

install -d %{buildroot}%{_sysconfdir}/dracut.conf.d/
install %{name}-oob.conf %{buildroot}%{_sysconfdir}/dracut.conf.d/

%define _unpackaged_files_terminate_build 0

%postun doc
if [ -f %{_mandir}/man7/ice.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/depmod.d/%{name}.conf
%{_sysconfdir}/dracut.conf.d/%{name}-oob.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/ice.7.gz
%doc source/COPYING source/README

%changelog
* Fri Jul 23 2021 HPE Linux SW Deliverables <Linux_SWdeliverables@external.groups.hpe.com> 1.6.4-1
- Addressing the issue of system reboot on unloading iavf driver with maxvfs enabled in switchdev mode

* Tue Oct 6 2020 HPE Linux SW Deliverables <Linux_SWdeliverables@external.groups.hpe.com> 1.2.0-1
- Add RHEL7u9 support

* Wed Sep 23 2020 HPE Linux SW Deliverables <Linux_SWdeliverables@external.groups.hpe.com> 1.1.4-1
- Add RHEL8u3 support

* Mon Aug 10 2020 HPE Linux SW Deliverables <Linux_SWdeliverables@external.groups.hpe.com> 1.0.4-1
- Add SLES15 SP2 support

* Tue Jul 14 2020 HPE Linux SW Deliverables <Linux_SWdeliverables@external.groups.hpe.com> 0.13.1-1
- Fix return values and prints in VF MAC add/del flow
- Fix kernel panic after transiting FW LLDP from on to off and restarting lldpad
- Fix Throughput lower than expected.
* Tue Sep 17 2019 HPE Linux SW Deliverables <Linux_SWdeliverables@external.groups.hpe.com> 0.11.7-1
- Initial package


